<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * display_messages.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This contains all messages, including information, error, and just
 * about any other message you can think of.
 *
 * $Id: display_messages.php,v 1.1 2004/02/02 14:00:13 marco Exp $
 */

if (!defined('SM_PATH')) { define('SM_PATH','../'); }

//require plugin.php here to avois a do_hook error on session timeout
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/global.php');

/**
 * Find out where squirrelmail lives and try to be smart about it.
 * The only problem would be when squirrelmail lives in directories
 * called "src", "functions", or "plugins", but people who do that need
 * to be beaten with a steel pipe anyway.
 *
 * @return  the base uri of squirrelmail installation.
 */
function sqm_baseuri(){
    global $base_uri, $PHP_SELF;
    /**
     * If it is in the session, just return it.
     */
    if (isset($base_uri)){
        return $base_uri;
    }
    $dirs = array('|src/.*|', '|plugins/.*|', '|functions/.*|');
    $repl = array('', '', '');
    $base_uri = preg_replace($dirs, $repl, $PHP_SELF);
    return $base_uri;
}

function error_username_password_incorrect() {
    global $frame_top, $color;
    global $squirrelmail_plugin_hooks;
    /* XXX: Should really not start the HTML before this, or close off more
       cleanly. */
    if (!isset($frame_top)) {
        $frame_top = '_top';
    }
    $string = '<TR><TD class="nav" ALIGN="center">'.
                 codeHTML(_("Unknown user or password incorrect.")) .
              '</TD></TR><TR><TD class="optionlink" ALIGN="center">'.
	         '<A HREF="' . sqm_baseuri() . '"login.php" TARGET='.
                    $frame_top.'>' . codeHTML(_("Click here to try again")) .
                    '</A>.'.
              '</TD></TR>';
    error_box($string,$color); 
}

function error_message($message, $mailbox, $sort, $startMessage, $color) {
    $urlMailbox = urlencode($mailbox);
    global $squirrelmail_plugin_hooks; 

    $string = '<tr><td class="nav" ALIGN="center">' . $message . '</td></tr>'."\n".
               '<tr><td class="optionlink" ALIGN="center">'.
                  '<A HREF="' . sqm_baseuri() 
                  . "src/right_main.php?sort=$sort&startMessage=$startMessage"
                  . "&mailbox=$urlMailbox\">" .
	    codeHTML(sprintf (_("Click here to return to %s"), imap_utf7_decode_local($mailbox))) .
	    '</A></td></tr>';
    error_box($string, $color);
}

function plain_error_message($message, $color) {
    error_box($message, $color);
}

function logout_error( $errString, $errTitle = '' ) {
    global $frame_top, $org_logo, $org_name, $org_logo_width, $org_logo_height,
           $hide_sm_attributions, $version, $squirrelmail_language;
    global $squirrelmail_plugin_hooks;
    $base_uri = sqm_baseuri();

    include_once( SM_PATH . 'functions/page_header.php' );
    if ( !isset( $org_logo ) ) {
        // Don't know yet why, but in some accesses $org_logo is not set.
        include( SM_PATH . 'config/config.php' );
    }
    /* Display width and height like good little people */
    $width_and_height = '';
    if (isset($org_logo_width) && is_numeric($org_logo_width) && $org_logo_width>0) {
        $width_and_height = " WIDTH=\"$org_logo_width\"";
    }
    if (isset($org_logo_height) && is_numeric($org_logo_height) && $org_logo_height>0) {
        $width_and_height .= " HEIGHT=\"$org_logo_height\"";
    }

    if (!isset($frame_top) || $frame_top == '' ) {
        $frame_top = '_top';
    }

    if ( !isset( $color ) ) {
        $color = array();
        $color[0]  = '#DCDCDC';  /* light gray    TitleBar               */
        $color[1]  = '#800000';  /* red                                  */
        $color[2]  = '#CC0000';  /* light red     Warning/Error Messages */
        $color[4]  = '#FFFFFF';  /* white         Normal Background      */
        $color[7]  = '#0000CC';  /* blue          Links                  */
        $color[8]  = '#000000';  /* black         Normal text            */
    }

    list($junk, $errString, $errTitle) = do_hook('logout_error', $errString, $errTitle);

    if ( $errTitle == '' ) {
        $errTitle = $errString;
    }
    set_up_language($squirrelmail_language, true);

    displayHtmlHeader( $errTitle );

    echo '<BODY class="bodylogin">';
    echo '<br /><br /><br /><br />'."\n";
    echo '<table align="center" valign="middle" height="50%" class="border" border="0" cellspacing="0" cellpadding="0" width="50%">'."\n";
        if (isset($org_logo)) {
            echo '<tr>
                    <td class="nav" align="center" colspan=2>
                        <img src="'.$org_logo.'" alt="'.sprintf(_("%s Logo"), $org_name).'"
                        border=0 '.$width_and_height.'>
                    </td>
                </tr>'."\n";
        }
        if (isset($hide_sm_attributions) && $hide_sm_attributions) {
            echo '<tr>
                    <td class="nav" align="center" colspan=2>
                        &nbsp;
                    </td>
                </tr>'."\n";
        } else {
            echo '<tr>
                    <td class="small" align="center" colspan=2>
                        '.codeHTML(sprintf (_("SquirrelMail version %s"), $version)).'
                    </td>
                </tr>'."\n";
            echo '<tr>
                    <td class="small" align="center" colspan=2>
                        '.codeHTML(_("By the SquirrelMail Development Team")).'
                    </td>
                </tr>'."\n";
        }
        echo '<tr>
                    <td class="optionlink" align="center" colspan=2>
                        '.codeHTML(_("ERROR")).'
                    </td>
                </tr>'."\n";

        echo '<TR><TD ALIGN="center" class="nav">' . codeHTML($errString) . '</TD></TR>';
        echo '<tr>
                    <td class="optionlink" align="center">
                        <a href="' . $base_uri . 'src/login.php" target="' . $frame_top . '">' .
                        codeHTML(_("Go to the login page.")) . '</a>
                    </td>
                </tr>'."\n";
	echo '</table></body></html>';
}

function error_box($string, $color) {
    global $pageheader_sent;

    $ret = concat_hook_function('error_box', $string);
    if($ret != '') {
        $string = $ret;
    }

    /* check if the page header has been sent; if not, send it! */
    if(!isset($pageheader_sent) && !$pageheader_sent) {
        /* include this just to be sure */
        include_once( SM_PATH . 'functions/page_header.php' );
        displayHtmlHeader('OverLook: '._("ERROR"));
        $pageheader_sent = TRUE;
        echo '<body class="bodylogin">';
    }

   echo '        <tr><td ALIGN="center" class="optionlink">';
   echo codeHTML(_("ERROR"));
   echo '        </td></tr>';
   echo $string;
}
?>
