<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * Message and Spam Filter Plugin
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This plugin filters your inbox into different folders based upon given
 * criteria. It is most useful for people who are subscibed to mailing lists
 * to help organize their messages.  The argument stands that filtering is
 * not the place of the client, which is why this has been made a plugin for
 * SquirrelMail.  You may be better off using products such as Sieve or
 * Procmail to do your filtering so it happens even when SquirrelMail isn't
 * running.
 *
 * If you need help with this, or see improvements that can be made, please
 * email me directly at the address above.  I definately welcome suggestions
 * and comments.  This plugin, as is the case with all SquirrelMail plugins,
 * is not directly supported by the developers.  Please come to me off the
 * mailing list if you have trouble with it.
 *
 * Also view plugins/README.plugins for more information.
 *
 * $Id: options_filters.php,v 1.1 2004/02/02 14:00:13 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/imap_mailbox.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/forms.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/options.php');
require_once(SM_PATH . 'plugins/filters/filters.php');

/* get globals */
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('key', $key, SQ_COOKIE);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION);
sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION); 

sqgetGlobalVar('action', $action, SQ_GET);

global $custom_css;

if (isset($_GET['theid'])) {
    sqgetGlobalVar('theid', $theid, SQ_GET);
} else if (isset($_POST['theid'])) {
    sqgetGlobalVar('theid', $theid, SQ_POST);
} else {
    $theid = 0;
}

$return_message_scan="";

   if (isset($_POST['filter_submit'])) {
      sqgetGlobalVar('filter_what', $filter_what, SQ_POST);
      sqgetGlobalVar('filter_where', $filter_where, SQ_POST);
      sqgetGlobalVar('filter_folder', $filter_folder, SQ_POST);
      $filter_what = str_replace(',', ' ', $filter_what);
      $filter_what = str_replace("\\\\", "\\", $filter_what);
      $filter_what = str_replace("\\\"", '"', $filter_what);
      setPref($data_dir, $username, 'filter'.$theid, $filter_where.','.$filter_what.','.$filter_folder);
      $action = "";	
   } else if (isset($action) && $action == 'delete') {
      remove_filter($theid);
   } else if (isset($action) && $action == 'move_up') {
      filter_swap($theid, $theid - 1);
   } else if (isset($action) && $action == 'move_down') {
      filter_swap($theid, $theid + 1);
   } else if (isset($_POST['user_submit'])) {
        setPref($data_dir, $username, 'filters_user_scan', $_POST['filters_user_scan_set']);
        setPref($data_dir, $username, 'filters_sent_folder', $_POST['filters_sent_folder']);
	$return_message_scan = '<tr height="1%">
	    			<td align="center" width="80%" class="success" colspan=2>
				    '.codeHTML(_("Saved Scan type")).'
				</td>
			    </tr>'."\n";
   }

    $filters = load_filters();
    $filters_user_scan = getPref($data_dir, $username, 'filters_user_scan');
    $filters_sent_folder = getPref($data_dir, $username, 'filters_sent_folder');

    if (!isset($action) || (isset($action) && $action != 'edit')) { $theid = count($filters); }  

    if (isset($filters[$theid]['folder']) && $filters[$theid]['folder']) { 
	$a = explode(".",$filters[$theid]['folder']);
	$filter_folder_label = array_pop($a); 	
    } else {
	$filter_folder_label = "";
    }

//********************************* START HTML ****************************//

$optpage_name = _("Filters");

$js = '
function ChoisedFolder(field_value) {
    document.s.filter_folder.value=field_value;
    var a = field_value.split(".");
    document.s.filter_folder_label.value = a.pop();
}
function OnSubmitIT() {
    var expr = /.+:.+/;
    var result = document.s.filter_what.value.match(expr);
    if (!document.s.filter_folder.value) {
        alert("'.jsspecialchars(_("Please select a folder!")).'");
        return false;
    } else if (!document.s.filter_what.value) {
        alert("'.jsspecialchars(_("Please insert a string in contains")).'");
        document.s.filter_what.focus();
        return false;
    } else if (document.s.filter_where.value == "Header" && result == null) {
	alert("'.jsspecialchars(_("WARNING! Header filters should be of the format 'Header:value'!")).'");
        document.s.filter_where.focus();
	return false;
    }
    return true;
}'."\n";
 
$js = '<script language="javascript">'.$js.'</script>';  

displayHtmlHeader(_("Options - Filters"),$js);
 
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/tips.js"></script>';
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/ctrl_form.js"></script>';
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/new_window.js"></script>'."\n";
 
echo '<body>';

echo '<table class="border" valign="top" width="100%" height="100%" cellpadding="0" cellspacing="0" border="0">';
 
ShowOptionBar();

    echo '<tr valign="top"><td width="100%" height="1%" valign="top">';  
	echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	echo addForm($base_uri.'plugins/filters/options_filters.php', 'POST', 'scan');
        echo '<tr height="1%">
                <td align="left" width="100%" class="optionlink" colspan=2>
                    '.codeHTML(_("Filter type")).'
                </td>
            </tr>'."\n";
	if ($return_message_scan) { echo $return_message_scan; }
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
		    '.codeHTML(_("What to Scan")).':
                </td>
                <td align="left" class="nav">';
		    echo addSelect('filters_user_scan_set', 
			    array('' => _("All messages"),'new' => _("Only unread messages")), 
			    $filters_user_scan, TRUE);
    	    echo '</td>
            </tr>'."\n";

        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
		    '.codeHTML(_("Scan even sent folder (may be slow)?")).'
                </td>
                <td align="left" class="nav">';
		    if ($filters_sent_folder) { $yes = TRUE; $no = FALSE; }
		    else { $yes = FALSE; $no = TRUE; }
    		    echo addRadioBox('filters_sent_folder', $yes, 1).'&nbsp;'._("Yes");
    		    echo addRadioBox('filters_sent_folder', $no, 0).'&nbsp;'._("No");
    	    echo '</td>
            </tr>'."\n";

        echo '<tr height="1%">
                <td align="center" width="100%" class="nav" colspan=2>';
	    echo addHidden('user_submit',_("Save"));
	    echo addButton(_("Save"), '','','','scan');
        echo '  </td>
            </tr>'."\n";
    echo '</table></form></td></tr>';   

    echo '<tr valign="top"><td width="100%" height="1%" valign="top">';  
	echo addForm($base_uri.'plugins/filters/options_filters.php', 'POST', 's');
	echo addHidden('theid', $theid);
        if (isset($filters[$theid]['folder']) && $filters[$theid]['folder']) {
	    echo addHidden('filter_folder', $filters[$theid]['folder']);
	} else {
	    echo addHidden('filter_folder', '');
	}
	echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
        echo '<tr height="1%">
                <td align="left" width="100%" class="optionlink" colspan=2>
                    '.codeHTML(_("Add/Modify Filter")).'
                </td>
            </tr>'."\n";
    	echo '<tr height="1%">
        	<td width="30%" height="1%" align="left" class="nav">
            	    '.codeHTML(_("Match")).':
		</td>
        	<td height="1%" align="left" class="nav">';
		    echo addSelect('filter_where', 
			    array(
				'From' => _("From"),
				'To' => _("To"),
				'Cc' => _("Cc"),
				'To or Cc' => _("To or Cc"),
				'Subject' => _("Subject"),
				'Header' => _("Header")
			    ), $filters[$theid]['where'], TRUE);
		echo '</td>
	    </tr>'."\n";  
    	echo '<tr height="1%">
        	<td width="30%" height="1%" align="left" class="nav">
            	    '.codeHTML(_("Contains")).':
		</td>
        	<td height="1%" align="left" class="nav">';
		echo addInput('filter_what', $filters[$theid]["what"], '30');
	    echo '	</td>
	    </tr>'."\n";  
    	echo '<tr height="1%">
        	<td width="30%" height="1%" align="left" class="nav">
            	    '.codeHTML(_("Move to")).':
		</td>
        	<td height="1%" align="left" class="nav">';
		    echo addInput('filter_folder_label', $filter_folder_label, '30', '', 'disabled=1').'&nbsp;';
		    echo addButton(_("Select folder"),'','','new_win_overlook("move_email","'.$base_uri.'src/search_folder.php",400,333,1,180,150);','','',1,1);
                echo '</td>
	    </tr>'."\n";  
        echo '<tr height="1%">
                <td align="center" width="100%" class="nav" colspan=2>';
	    echo addHidden('filter_submit',_("Submit"));
	    echo addButton(_("Submit"), '','','','s','OnSubmitIT()');
        echo '  </td>
            </tr>'."\n";
    echo '</table></form></td></tr>';   

if (count($filters)) {
    echo '<tr valign="top" height="10">
            <td class="nav" align="center" width="100%">
                &nbsp;
            </td>
    </tr>';
    echo '<tr valign="top"><td height="1%">';
       echo '<table class="border" width="100%" height="1%" align="center" valign="top" cellpadding="2" cellspacing="2" border="0">';
            echo '<tr height="1%">
                    <td align="left" width="100%" class="optionlink" colspan=5>
                        '.codeHTML(_("Filters list")).'
                    </td>
                </tr>'."\n";
    for ($i=0; $i < count($filters); $i++) {
              echo'<tr height="1%">
                  <td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/filters/options_filters.php?theid='.$i.'&action=edit\'" valign="middle" align="center" class="nav">'._("Edit").'</td>
                  <td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/filters/options_filters.php?theid='.$i.'&action=delete\'" valign="middle" align="center" class="nav">'._("Delete").'</td>'."\n";
        if($i > 0) {
    	    echo '<td width="10%" onmouseover="this.className=\'navclicked\'"onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/filters/options_filters.php?theid='.$i.'&action=move_up\'" valign="middle" align="center" class="nav">
                            <img src="'.$base_uri.'images/'.$custom_css.'/up_pointer.png" border=0>
                        </td>';
        } else {
            echo '<td width="10%" valign="middle" align="center" class="nav">&nbsp;</td>';
 
        }
        if (isset($filters[$i + 1])) {
            echo '<td width="10%" onmouseover="this.className=\'navclicked\'"onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/filters/options_filters.php?theid='.$i.'&action=move_down\'" valign="middle" align="center" class="nav">
                            <img src="'.$base_uri.'images/'.$custom_css.'/down_pointer.png" border=0>
                        </td>';
        } else {
            echo '<td width="10%" valign="middle" align="center" class="nav">&nbsp;</td>';
        }
            echo '<td valign="middle" align="center" class="nav">';
    		    $a = explode(".",$filters[$i]['folder']);
    		    $filter_folder_label = array_pop($a); 	
    		    echo sprintf( _("If <b>%s</b> contains <b>%s</b> then move to <b>%s</b>"), codeHTML($filters[$i]['where']), codeHTML($filters[$i]['what']), codeHTML($filter_folder_label) );
	    echo '</td>
              </tr>';
    }
    echo '</table></form></td></tr>';   
} else {
    echo '<tr><td height="100%" align="center" valign="middle" class="nav" width="100%">';
    echo codeHTML(_("No Filter is defined and in use")) . "</td></tr>";
}    
echo '<tr valign="top">
            <td class="nav" align="center" width="100%" colspan=5>
                &nbsp;
            </td>
        </tr>';
echo '</table>';
echo $echotips;
echo '</body></html>';
?>