<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * gpg_options.php
 * --------------------
 * Main wrapper for the options interface.
 *
 * Copyright (c) 1999-2002 The SquirrelMail development team
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @package gpg
 *
 * $Id: gpg_options.php,v 1.10 2003/11/04 21:38:41 brian Exp $
 *
 * @todo modify options_main and gpg_module_footer to accept a backlink defined by the module file that is included
 *
 */
if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in gpg_options.php, exiting abnormally";
}
require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'plugins/gpg/gpg_functions.php');
require_once(SM_PATH.'plugins/gpg/gpg_options_header.php');

/**
 * $MOD is the name of the module to invoke.
 * If $MOD is unspecified, assign "init" to it. Else check for
 * security breach attempts.
 */

sqgetGlobalVar('MOD',$MOD);

if(!isset($MOD) || !$MOD) { $MOD = 'options_main'; } 
else { gpg_ckMOD($MOD); }

//set up the page format
require_once(SM_PATH.'plugins/gpg/modules/gpg_module_header.php');

echo '<tr>
	<td align="left" width="100%" valign="top">
	    <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

if (gpg_https_connection()) {
    /**
    * Load the module file already.
    */
    require_once(SM_PATH."plugins/gpg/modules/$MOD.mod");
} else {
    echo '<tr>
        <td align="left" width="100%" height="30%" class="nav">
                    &nbsp;
                </td>
            </tr>';
    echo '<tr height="1%">
                <td align="center" width="100%" colspan=2 class="nav">
		    <font color="red">'.codeHTML(_("This action can only be performed on a secure connection (https).\n Please change the 'http' in your address bar to 'https', and try again.")).'</font>
		</td>
	    </tr>';
}

echo '<tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';
echo '</table></tr><td></table>';

/**
 * @todo define a backlink variable in gpg_module_footer.php that can be set by the module file
 */
//pull in the footer
require_once(SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
 *
 * $Log: gpg_options.php,v $
 * Revision 1.10  2003/11/04 21:38:41  brian
 * change to use SM_PATH
 *
 * Revision 1.9  2003/11/01 22:01:26  brian
 * infrastructure changes to support removal of MakePage functions
 *
 * Revision 1.8  2003/10/17 13:12:05  brian
 * corrected phpdoc warnings after updates
 *
 * Revision 1.7  2003/10/17 12:50:20  brian
 * added package and author tags
 *
 * Revision 1.6  2003/07/09 01:44:27  brian
 * modified require_once directive to reflect different locations we can be called from
 *
 * Revision 1.5  2003/07/08 18:02:51  vermette
 * using new gog_options_header.  No functional change
 *
 * Revision 1.4  2003/03/07 00:12:52  brian
 * Removed superflous includes.
 *
 * Revision 1.3  2002/12/10 03:46:20  brian
 * updated to not require gpg_config, as it is required by gpg_functions
 *
 *
 */
?>
