<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in gpg_options.php, exiting abnormally";
}

global $err;

require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');
require_once(SM_PATH.'plugins/gpg/gpg_functions.php');
require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

sqgetGlobalVar('fpr', $fpr, SQ_GET);
sqgetGlobalVar('err', $err, SQ_GET);
sqgetGlobalVar('pos', $pos, SQ_GET);
sqgetGlobalVar('sort', $sort, SQ_GET);
sqgetGlobalVar('desc', $desc, SQ_GET);
sqgetGlobalVar('srch', $srch, SQ_GET);
sqgetGlobalVar('ring', $ring, SQ_GET);

sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);

require_once(SM_PATH."plugins/gpg/modules/gpg_module_header.php");

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

// ===============================================================
$section_title = _("Change Passphrase");
gpg_page_title( $section_title );
// ===============================================================

echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top" colspan=2>';

echo codeHTML(_("You can change your passphrase from this screen.  More help will be available in the future."));

if ($err) {
    echo '<p>'
         . '<font color="red">';
    echo codeHTML(_("Error: "));
    echo '<br>'
         . $err
         . '</font><br>';
}

echo '</td></tr>';

echo addForm($base_uri.'plugins/gpg/modules/keyring_main.php', 'POST');

echo addHidden('fpr', $fpr);
echo addHidden('pos', $pos);
echo addHidden('sort', $sort);
echo addHidden('desc', $desc);
echo addHidden('srch', $srch);
echo addHidden('ring', $ring);

echo '<tr valign="top"><td height="1%" class="nav" align="left" width="50%" valign="top">';

echo codeHTML(_("Please type your old passphrase: "));

echo '</td><td height="1%" class="nav" align="left" width="50%" valign="top">';

echo addPwField('oldpassphrase','','id="oldpw" size="50" limit="100" progress="false" nolimit="true"');

echo '</td></tr>';

echo '<tr valign="top"><td height="1%" class="nav" align="left" valign="top">';

echo codeHTML(_("Enter New Passphrase:"));

echo '</td><td height="1%" class="nav" align="left" width="50%" valign="top">';

echo addPwField('passphrase','','id="pw" size="50" limit="100" progress="true" nolimit="true"');

echo '</td></tr>';

echo '<tr valign="top"><td height="1%" class="nav" align="left" valign="top">';

echo codeHTML(_("Retype New Passphrase:"));

echo '</td><td height="1%" class="nav" align="left" width="50%" valign="top">';

echo addPwField('passphrase2','','id="pw2" size="50" limit="100" progress="true" nolimit="true"');

echo '</td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top" colspan=2>';

echo addButton(_("Cancel"),'can','','history.back(-1)','','',true,true);
echo '&nbsp;';
echo addSubmit(_("Change Passphrase"),'changepass','','','','',true,true);

echo '</td></tr>';

echo '<tr>
        <td align="left" width="100%" class="nav" colspan=2>
                    &nbsp;
                </td>
            </tr>';
echo '</table></td></tr></table>';

require_once('gpg_module_footer.php');

/**
 * For Emacs weenies:
 * Local variables:
 * mode: php
 * c-basic-offset: 4
 * End:
 */

/**
 *
 * $Log: changepass.php,v $
 * Revision 1.4  2003/11/03 19:57:09  brian
 * minor wording changes in advance of translation.
 * Bug 35
 *
 * Revision 1.3  2003/10/30 20:28:59  brian
 * modified all localized strings to use double quotes.
 * Bug 35
 *
 * Revision 1.2  2003/10/29 00:20:17  walter
 * - localized text by sentences
 * Bug 35
 * -  updated Help structure
 * Bug 79
 *
 * Revision 1.1  2003/10/10 19:08:17  ke
 * -adding module for change passphrase interface
 *
 * Revision 1.6  2003/08/13 06:49:42  vermette
 * minor fix
 *
 * Revision 1.5  2003/07/17 07:33:07  vermette
 * time-saving modifications to hack around gpg's lack of ability to restrict output size.  Added system keyring into consolidated interface.
 *
 * Revision 1.4  2003/07/11 07:43:12  vermette
 * added search to keyring_main
 *
 * Revision 1.3  2003/07/11 06:54:03  vermette
 * keyring work.  Added chunking, first/prev/next/last, sorting, and ascending v. descending sorted view.  Also modified key table to give more info.
 *
 * Revision 1.2  2003/07/08 18:01:51  vermette
 * rename publicring.php to keyring_main.php
 *
 * Revision 1.1  2003/07/08 17:55:34  vermette
 * new pages for import functionality
 *
 * Revision 1.3  2003/07/01 06:21:46  vermette
 * adding escape routes to options suite.  The previous 'back' link now only appears if requested (new arg to makePage).  This isn't done by any means, but at most it's as broken as it was, so it's an improvement.
 *
 * Revision 1.2  2003/06/13 15:18:01  brian
 * modified to remove $msg parameter to $gpg_format_keylist fn call
 *
 * Revision 1.1  2003/04/11 14:09:10  brian
 * nitial Revision
 * display public keyring with radio 'false'
 * Bug 27
 * .
 *
 */

?>
