<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * genkey.php
 * ----------------
 * GPG Key Generation page
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @author Joshua Vermette
 * @author Aaron Van Meerten
 * @author Brian Peterson
 *
 * $Id: genkey.php,v 1.26 2003/12/27 18:01:25 brian Exp $
 */

global $err;

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in genkey.php, exiting abnormally";
}

require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

//Cancelling?
sqgetGlobalVar('can', $can, SQ_POST);
sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION);

if (isset($can)) {
    if ($can) {
        //Send them back to getting started
        require_once(SM_PATH.'plugins/gpg/modules/keyring_main.php');
        exit;
    }
}

require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');
require_once(SM_PATH.'plugins/gpg/gpg_functions.php');

//Are they on a secure connection?
if (!gpg_https_connection()) {
    $notSecure = true;
    require_once(SM_PATH.'plugins/gpg/modules/keyring_main.php');
    exit;
}

//include the gpg system header, so's everything will be in place.
//Have to chdir so included includes will work.
require(SM_PATH.'plugins/gpg/modules/gpg_module_header.php');

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

sqgetGlobalVar('pos', $pos, SQ_GET);
sqgetGlobalVar('sort', $sort, SQ_GET);
sqgetGlobalVar('desc', $desc, SQ_GET);
sqgetGlobalVar('srch', $srch, SQ_GET);
sqgetGlobalVar('ring', $ring, SQ_GET);

//Make the passthrough string for keyring_main.
$thru = ("pos=" . $pos) .
     "&sort=" . urlencode($sort) .
     "&desc=" . urlencode($desc) .
     "&srch=" . urlencode($srch) .
     "&ring=" . urlencode($ring);

echo '<link rel="STYLESHEET" type="text/css" href="'.$base_uri.'plugins/gpg/js/bar-styles.css">';

// ===============================================================
$section_title = _("GPG Options - Create a Personal Keypair");
gpg_page_title($section_title );
// ===============================================================

//Output any error we found.
require(SM_PATH.'plugins/gpg/modules/gpg_err.php');

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("To sign outgoing mail and receive encrypted messages, you must have a personal Keypair."));
echo '</td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("A ")).'<b>'.codeHTML(_("Keypair")).'</b>'.codeHTML(_(" consists of a")). '<b>'.codeHTML(_("public key")).'</b>'.codeHTML(_(", which people will use to send encrypted messages to you and verify your signature, and a secret key, which will never be shared with others."));
echo '</td></tr>';

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo '<b>'.codeHTML(_("Do you already have a personal Keypair?")).'</b>';
echo '</td></tr>';

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("Import keys to your personal keyring via: "));
    echo '<a class="gpg" href="'.$base_uri.'plugins/gpg/modules/import_key_file.php">'.codeHTML(_("file")).'</a>&nbsp;';
    echo codeHTML(_("or")). '&nbsp;<a class="gpg" href="'.$base_uri.'plugins/gpg/modules/import_key_text.php">'. codeHTML(_("text")). '</a>.';
echo '</td></tr>';

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("Storing a private key on a remote host can be insecure if you do not trust the host!"));
    echo '['. gpg_add_help_link ( 'disc_keystore.php' );
    echo codeHTML(_("disclaimer"));
    echo  '</a>'. ']';
echo '</td></tr>';

//start by searching for the user's information from the options they've entered.
$email_address = getPref($data_dir, $username, 'email_address');
$full_name = getPref($data_dir, $username, 'full_name');

echo '<tr valign="top"><td width="100%" height="1%" align="center" class="nav">';

    echo addForm($base_uri.'plugins/gpg/modules/genkey_keygen.php', 'POST','genkey_form');
    echo addHidden('pos', $pos);
    echo addHidden('sort', $sort);
    echo addHidden('desc', $desc);
    echo addHidden('srch', $srch);
    echo addHidden('ring', $ring);

    //bordo esterno
    echo  '<table cellpadding="1" cellspacing="0" border="0" width="60%">';
	echo '<tr><td bgcolor="#000000">';
    //tabella interna
    echo '<table cellpadding="3" cellspacing="1" bgcolor="#FFFFFF" border="0" width="100%">';
	//titolo
	echo '<tr><td bgcolor="#FFFFCC" colspan=2>';
	    echo codeHTML(_("Generate New Keypair"));
	echo '</td></tr>';
	// full name
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Full Name")).':</td>';
	    echo '<td nowrap=1>';
		echo addInput('full_name', $full_name, 70, '', 'id="full_name" required="true" datatype="names" title="Name"');
	    echo '</td>';
	echo '</tr>';
	//email
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Email Address")).':</td>';
	    echo '<td nowrap=1>';
		echo addInput('email_address', $email_address, 70, '', 'id="email_address" required="true" datatype="email" title="eMail"');
	    echo '</td>';
	echo '</tr>';
	// key_strength
	$array_key_strength = array();
	for ($i=0; $i < $GLOBALS['GPG_SYSTEM_OPTIONS']['keystrengths']; $i++) {
	    $keystrength=$GLOBALS['GPG_SYSTEM_OPTIONS']['keystrength'.$i];
	    $array_key_strength[$keystrength] = $keystrength;
	    if ($keystrength == $GLOBALS['GPG_SYSTEM_OPTIONS']['default_keystrength']) {
    		$default_keystrength = $keystrength;
	    }
	}
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Keystrength")).':</td>';
	    echo '<td nowrap=1>';
		echo addSelect('key_strength', $array_key_strength, $default_keystrength);
		echo '&nbsp;['.gpg_add_help_link ( 'what_keystrength.php' ).codeHTML(_("What's this?")).'</a>]';
	    echo '</td>';
	echo '</tr>';
	//Key Expires
	$default_key_expires = $GLOBALS['GPG_SYSTEM_OPTIONS']['default_keyexpires'];
	$array_key_expires = array();
	$array_key_expires[0] = _("Never");
	$array_key_expires[30] = '30'._("Days");
	$array_key_expires[90] = '90'._("Days");
	$array_key_expires[180] = '180'._("Days");
	$array_key_expires['1y'] = _("1 Year");
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Key Expires")).':</td>';
	    echo '<td nowrap=1>';
		echo addSelect('key_expires', $array_key_expires, $default_key_expires,true);
	    echo '</td>';
	echo '</tr>';
	//Enter Passphrase
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Enter Passphrase")).':</td>';
	    echo '<td nowrap=1>';
		echo addPwField('passphrase', '', 'id="passphrase" size="70" limit="100" progress="true" nolimit="true" required="true" compare="passphrase2" title="'.codeHTML(_("First Passphrase")).'"');
	    echo '</td>';
	echo '</tr>';
	//Retype Passphrase
	echo '<tr>';
	    echo '<td nowrap=1>'.codeHTML(_("Retype Passphrase")).':</td>';
	    echo '<td nowrap=1>';
		echo addPwField('passphrase2', '', 'id="passphrase2" size="70" limit="100" progress="true" nolimit="true" required="true" compare="passphrase2" title="'.codeHTML(_("Second Passphrase")).'"');
	    echo '</td>';
	echo '</tr>';
	//sybmits
	echo '<tr>';
	    echo '<td nowrap=1 colspan=2 align="center">';
//		echo addSubmit(_("Create New Personal Keypair"), '','Xonclick="return checkpassphrase(document.genkey_form);"','','','',true,true);
		echo addSubmit(_("Create New Personal Keypair"), '','','','','',true,true);
	    echo '</td>';
	echo '</tr>';
        echo '</form>';
	echo '</table>';
	echo '</td></tr>';	
    echo '</table>';
  echo '</td></tr>';	
echo '<tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';
echo '</table>';

//echo '<script src="'.$base_uri.'plugins/gpg/js/events.js" language="JavaScript" type="text/javascript"></script>';
//echo '<script src="'.$base_uri.'plugins/gpg/js/statusBar.js" language="JavaScript" type="text/javascript"></script>';
//echo '<script src="'.$base_uri.'plugins/gpg/js/formValidation.js" language="JavaScript" type="text/javascript"></script>';

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
 * For Emacs weenies:
 * Local variables:
 * mode: php
 * c-basic-offset: 4
 * End:
 */

/**
 *
 * $Log: genkey.php,v $
 * Revision 1.26  2003/12/27 18:01:25  brian
 * added Walter's improved formatting of html tags
 *
 * Revision 1.25  2003/12/23 12:47:56  brian
 * removed superfluous error message
 *
 * Revision 1.24  2003/12/05 20:38:09  ke
 * -untranslated "selected" term as it is a code word in HTML, not translated text
 *
 * Revision 1.23  2003/12/05 20:34:46  ke
 * -changed &nbsp to space to allow default keystrength to be set properly
 *
 * Revision 1.22  2003/12/03 00:24:48  brian
 * added .php to disc_keystore link
 *
 * Revision 1.21  2003/12/01 16:24:59  walter
 * - modified default error message for NAME
 * Bug 119
 *
 * Revision 1.20  2003/11/22 21:13:10  brian
 * - fixed bug reported by Brad Donison
 * - needed .php after the names of help files in new help infrastructure
 *
 * Revision 1.19  2003/11/19 16:17:03  walter
 * - updated for new datatype - 'is_names'
 *
 * Revision 1.18  2003/11/08 21:41:06  walter
 * - corrected form validation for password varification
 * - corrected display of status bars
 *
 * Revision 1.17  2003/11/07 20:57:01  walter
 * - removed in script javascript for passphrase compare
 * - added INCLUDE code for passphrase compare
 *
 * Revision 1.16  2003/11/06 17:18:05  walter
 * - moved FORM tags outside TABLE
 * - corrected status bar issues
 * BUG 73
 * - added field validation
 *
 * Revision 1.15  2003/11/04 21:41:01  brian
 * change to use SM_PATH
 *
 * Revision 1.14  2003/11/03 19:40:35  brian
 * minor wording changes in advance of translation.
 * Bug 35
 *
 * Revision 1.13  2003/11/01 21:59:10  brian
 * - standardized text across several pages
 * - localized remaining strings
 *
 * Revision 1.12  2003/10/30 21:05:22  brian
 * fixed problems apparent in the xgettext index
 * Bug 35
 *
 * Revision 1.11  2003/10/30 20:28:59  brian
 * modified all localized strings to use double quotes.
 * Bug 35
 *
 * Revision 1.10  2003/10/30 02:17:03  walter
 * - completed localized text by sentences
 * Bug 35
 *
 * Revision 1.9  2003/10/29 00:20:17  walter
 * - localized text by sentences
 * Bug 35
 * -  updated Help structure
 * Bug 79
 *
 * Revision 1.8  2003/10/15 18:42:17  walter
 * localized button text
 * Bug 35
 *
 * Revision 1.7  2003/10/14 20:23:22  walter
 * localized text
 * Bug 35
 *
 * Revision 1.6  2003/10/07 17:31:23  walter
 * Bug 62
 *
 * Revision 1.5  2003/10/07 17:29:54  walter
 * - added external javascript method to display a status bar indicating strength of encryption passphrase.
 * - Bug 62
 *
 * Revision 1.4  2003/10/01 19:53:46  ke
 * -Added keystrengths count and keystrength0-count available keystrengths
 * -Added default_keystrength option
 * -this takes care of min, max and default
 * -Added expiration timespans back into interface
 * -Added default_keyexpires timespan, specified in gpg timespan format (# for days or 1y for year)
 * -Options of 0 (never) 30 90 180 days 1 year
 * bug 61
 *
 * Revision 1.3  2003/09/10 16:06:27  ke
 * Added 3072 bit keysize option
 *
 * Revision 1.2  2003/08/14 02:38:04  vermette
 * minor html fix
 *
 * Revision 1.1  2003/08/13 07:34:05  vermette
 * new key generation suite
 *
 * Revision 1.5  2003/07/17 07:33:07  vermette
 * time-saving modifications to hack around gpg's lack of ability to restrict output size.  Added system keyring into consolidated interface.
 *
 * Revision 1.4  2003/07/11 07:43:12  vermette
 * added search to keyring_main
 *
 * Revision 1.3  2003/07/11 06:54:03  vermette
 * keyring work.  Added chunking, first/prev/next/last, sorting, and ascending v. descending sorted view.  Also modified key table to give more info.
 *
 * Revision 1.2  2003/07/08 18:01:51  vermette
 * rename publicring.php to keyring_main.php
 *
 * Revision 1.1  2003/07/08 17:55:34  vermette
 * new pages for import functionality
 *
 * Revision 1.3  2003/07/01 06:21:46  vermette
 * adding escape routes to options suite.  The previous 'back' link now only appears if requested (new arg to makePage).  This isn't done by any means, but at most it's as broken as it was, so it's an improvement.
 *
 * Revision 1.2  2003/06/13 15:18:01  brian
 * modified to remove $msg parameter to $gpg_format_keylist fn call
 *
 * Revision 1.1  2003/04/11 14:09:10  brian
 * nitial Revision
 * display public keyring with radio 'false'
 * Bug 27
 * .
 *
 */
?>
