<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * getstart.php
 * -----------
 * Page displayed when the "Getting Started" link is clicked.
 *
 * This is the Getting Started Page, which should hold a user's hand
 * through setting up the plugin.
 *
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @author Brian Peterson
 *
 * @todo modify getstart.php to use SM_PATH
 * @todo modify getstart.php to use new module interface
 *
 * $Id: getstart.php,v 1.11 2003/11/04 21:41:01 brian Exp $
 */
/*********************************************************************/

//include the gpg system header, so's everything will be in place.
//Have to chdir so included includes will work.
//chdir("../");

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in gpg_config.php, exiting abnormally";
}

require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');
require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_header.php');

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

// ===============================================================
$section_title = _("Encryption Options - Getting Started");
gpg_page_title( $section_title );
// ===============================================================

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("Welcome to the GPG Encryption Plugin for OverLook!"));
echo '</td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("This screen will help you set up the various options you need to get started using encryption."));
echo '</td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo codeHTML(_("With this interface, you will be able to encrypt, decrypt, and sign your email and attachments from the comfort of the OverLook web mail interface."));
echo '</td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav"><b>';
    echo codeHTML(_("The following is a list of suggested steps you can take to get started:"));
echo '</b></td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo '<ol>';
	echo '<li>
		    <b>'.codeHTML(_("Import external keys")).'</b>
		    <br>
		    '.codeHTML(_("Do you already have a keyring, or individual keys you would like to use?")).'
		    <br>
		    '.codeHTML(_("Import keys to your personal keyring via: ")).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/modules/import_key_file.php">
		    '.codeHTML(_("file")).'
		    </a>
		    '.codeHTML(_("or" )).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/modules/import_key_text.php">
		    '.codeHTML(_("text")).'
		    </a>
		    <br>
		    '.codeHTML(_("If not, skip this step.")).'
		</li>';
	echo '<li><b>'.codeHTML(_("Your personal Keypair")).'</b>
		    <br>
		    '.codeHTML(_("Did you import a personal Keypair in Step 1?")).'
		    &nbsp;
		    '.codeHTML(_("If not, you should")).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/modules/genkey.php">
		    '.codeHTML(_("generate a personal Keypair")).'
		    </a>
	    </li>';
	echo '<li>
		    <b>'.codeHTML(_("Configure a Trusted Key")).'</b>
		    <br>
		    '.codeHTML(_("Any key signed with your trusted key ID will be allowed for encryption without generating errors.")).'
		    &nbsp;
		    '.codeHTML(_("You can only have one trusted key at any given time.")).'
		    <br>
		    '.codeHTML(_("To set your trusted key, find the desired key in the 'public' or 'system' ring of the")).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/modules/keyring_main.php">	
		    '.codeHTML(_("keyring")).'
		    </a>
		    ,&nbsp;
		    '.codeHTML(_("click on it to view the details,")).'
		    &nbsp;
		    '.codeHTML(_("check 'This is my trusted key', and save.")).'
	    </li>';
	echo '<li>
		    <b>'.codeHTML(_("Select a Signing Key")).'</b>
		    <br>
		    '.codeHTML(_("Your signing key is the key you use to 'sign' a message you are sending, to prove that is from you.")).'
		    &nbsp;
		    '.codeHTML(_("You can only have one signing key at any given time.")).'
		    <br>
		    '.codeHTML(_("To set your signing key, find the desired key in the 'secret' ring of the")).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/modules/keyring_main.php">
		    '.codeHTML(_("keyring")).'
		    </a>
		    ,&nbsp;
		    '.codeHTML(_("click on it to view the details,")).'
		    &nbsp;
		    '.codeHTML(_("check 'This is my signing key' and save.")).'
		    &nbsp;
		    '.codeHTML(_("If you generated a personal Keypair in step 2, this is probably the key you want.")).'
	    </li>';
	echo '<li>
		    <b>'.codeHTML(_("Find the public keys of people you want to communicate securely with")).'</b>
		    <br>
		    '.codeHTML(_("You can")).'
		    <a class="gpg" href="'.$base_uri.'plugins/gpg/gpg_options.php?MOD=keyserver">
		    '.codeHTML(_("Look up keys on a public keyserver")).'
		    </a>
		    ,&nbsp;
		    '.codeHTML(_("and import them to your keyring.")).'
	    </li>';
    echo '</ol>';
echo '</td></tr>';

echo '<tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';
echo '</table>';

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
* For Emacs weenies:
* Local variables:
* mode: php
* End:
*/

/*******************************************************/
/*
 * $Log: getstart.php,v $
 * Revision 1.11  2003/11/04 21:41:01  brian
 * change to use SM_PATH
 *
 * Revision 1.10  2003/11/03 19:40:35  brian
 * minor wording changes in advance of translation.
 * Bug 35
 *
 * Revision 1.9  2003/11/03 18:35:09  brian
 * changed wording of secret key text for consistency
 *
 * Revision 1.8  2003/11/01 21:55:08  brian
 * - cleaned up echoes for readability
 * - localized remaining strings
 *
 * Revision 1.7  2003/10/30 20:37:14  ke
 * -changed single to double quotes in interationalized strings
 * Bug 35
 *
 * Revision 1.6  2003/10/30 02:17:03  walter
 * - completed localized text by sentences
 * Bug 35
 *
 * Revision 1.5  2003/10/29 00:20:17  walter
 * - localized text by sentences
 * Bug 35
 * -  updated Help structure
 * Bug 79
 *
 * Revision 1.4  2003/10/20 19:13:16  walter
 * added gpg_module_footer.php to page
 *
 * Revision 1.3  2003/10/10 02:27:26  brian
 * - localised file
 * - converted to pure php
 * - reconstituted page header and log comment blocks
 * Bug 35
 *
 *
 * ------------------------------------
 * Manually added log items below this line - brian
 *
 * Revision : 1.2 2003/9/6 14:36:53 'brian'
 * - fixed typos and page header.
 * @todo add comment header block and footer block
 * @todo internationalize all the code
 *
 * Revision : 1.1 2003/8/14 2:33:21 'vermette'
 * replacement for getstart.mod
 *
 * ------------------------------------
 * Log for getstart.mod below this line
 *
 * Revision 1.6  2003/08/14 02:40:36  vermette
 * replaced getstart.mod with getstart.php.
 * Removed unused components.
 *
 * Revision 1.5  2003/07/21 14:26:51  brian
 * - minor wording changes per J Nanninga request
 * - localization of all strings
 * Bug 35
 *
 * Revision 1.4  2003/07/08 13:39:26  brian
 * added backlink to gpg_makepage fn call
 *
 * Revision 1.3  2003/07/01 06:21:46  vermette
 * adding escape routes to options suite.
 * The previous 'back' link now only appears if requested (new arg to makePage).
 * This isn't done by any means, but at most it's
 * as broken as it was, so it's an improvement.
 *
 * Revision 1.2  2003/06/12 21:08:47  brian
 * removed extra comments in $Log
 *
 * Revision 1.1  2003/05/09 20:29:23  brian
 * Initial Revision
 * Bug 34
 */
?>
