<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
* importkey.mod
* -----------
*
* This code imports a key from the body of an email.
*
* Copyright (c) 2003 Braverock Ventures
* Licensed under the GNU GPL. For full terms see the file COPYING.
*
*
* $Id: importkey.mod,v 1.5 2003/11/04 21:41:01 brian Exp $
*/
/*********************************************************************/

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else { echo "unable to define SM_PATH in gpg_pop_init.php, exiting abnormally"; }
}

require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'plugins/gpg/gpg_key_functions.php');
require_once(SM_PATH.'functions/imap.php');
require_once(SM_PATH.'config/config.php');
require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');

global $debug;

sqgetGlobalVar('passed_id', $passed_id);
sqgetGlobalVar('mailbox', $mailbox);
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION);
sqgetGlobalVar('key', $key, SQ_COOKIE);

//get the body text
global $uid_support;

$imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

if ($imapConnection==false){
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';
        echo codeHTML(_("Connection to Imap Server to retrieve message body failed"));
    echo '</td></tr>';
};

$read = sqimap_mailbox_select($imapConnection, $mailbox, false, false, true);

$body_text = sqimap_run_command ($imapConnection, "FETCH $passed_id BODY[]",
                                true, $a, $b,$uid_support);

if (is_array($body_text)) { $body_text = implode($body_text,''); };

sqimap_logout($imapConnection);

//now call import
$ring = new gpg_keyring();
$return = $ring->importKey_text($body_text);

header("Location: " . $base_uri . 'plugins/gpg/modules/' . "keyring_main.php");

/*
* $Log: importkey.mod,v $
* Revision 1.5  2003/11/04 21:41:01  brian
* change to use SM_PATH
*
* Revision 1.4  2003/11/01 21:56:52  brian
* - removed $msg strings and gpg_Makepage functionality
* - localized remaining strings
*
* Revision 1.3  2003/09/19 18:27:08  ke
* Brought back importkey.mod in modules/ directory, added functionality to call keyring management after import.
*
* Revision 1.2  2003/08/14 02:39:30  vermette
* replaced with UI in consolidated interface
*
* Revision 1.1  2003/07/07 20:34:59  brian
* Initial Revision
* - code to import ASCII Armored keys from email body
* Bug 46
*
*/
?>