<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * mail_fetch/options.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Setup of the mailfetch plugin.
 *
 * $Id: options_fetch_mail.php,v 1.1 2004/02/02 14:00:13 marco Exp $
 */

define('SM_PATH','../../');

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'plugins/mail_fetch/functions.php');
require_once(SM_PATH . 'functions/forms.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/options.php');

/* globals */
sqgetGlobalVar('username',   $username,   SQ_SESSION);
sqgetGlobalVar('key',        $key,        SQ_COOKIE);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
sqgetGlobalVar('delimiter',  $delimiter,  SQ_SESSION);
 sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION);   
   
if(!sqgetGlobalVar('mf_cypher', $mf_cypher, SQ_POST)) {
    $mf_cypher = '';
}

if (!sqgetGlobalVar('mf_action', $mf_action, SQ_POST)) {
    sqgetGlobalVar('mf_action', $mf_action, SQ_GET);
}
sqgetGlobalVar('mf_action_m', $mf_action_m, SQ_POST); 
sqgetGlobalVar('mf_sn',            $mf_sn,            SQ_POST);
sqgetGlobalVar('mf_server',        $mf_server,        SQ_POST);
sqgetGlobalVar('mf_port',          $mf_port,          SQ_POST);
sqgetGlobalVar('mf_alias',         $mf_alias,         SQ_POST);
sqgetGlobalVar('mf_user',          $mf_user,          SQ_POST);
sqgetGlobalVar('mf_pass',          $mf_pass,          SQ_POST);
sqgetGlobalVar('mf_subfolder',     $mf_subfolder,     SQ_POST);
sqgetGlobalVar('mf_login',         $mf_login,         SQ_POST);
sqgetGlobalVar('mf_fref',          $mf_fref,          SQ_POST);
sqgetGlobalVar('mf_lmos',          $mf_lmos,          SQ_POST);

/* end globals */

//******************** Start Actions ********************//

    switch( $mf_action ) {
    case 'add':
        if (!isset($mf_server)) return;
    	setPref($data_dir,$username,"mailfetch_server_$mf_sn", (isset($mf_server)?$mf_server:""));
    	setPref($data_dir,$username,"mailfetch_port_$mf_sn", (isset($mf_port)?$mf_port:110));
    	setPref($data_dir,$username,"mailfetch_alias_$mf_sn", (isset($mf_alias)?$mf_alias:""));
    	setPref($data_dir,$username,"mailfetch_user_$mf_sn",(isset($mf_user)?$mf_user:""));
    	setPref($data_dir,$username,"mailfetch_pass_$mf_sn",(isset($mf_pass)?encrypt( $mf_pass )    :""));
    	if( isset($mf_cypher) && $mf_cypher <> 'on' ) SetPref($data_dir,$username,'mailfetch_cypher',    'on');
    	setPref($data_dir,$username,"mailfetch_lmos_$mf_sn",(isset($mf_lmos)?$mf_lmos:""));
    	setPref($data_dir,$username,"mailfetch_login_$mf_sn",(isset($mf_login)?$mf_login:""));
    	setPref($data_dir,$username,"mailfetch_fref_$mf_sn",(isset($mf_fref)?$mf_fref:""));
    	setPref($data_dir,$username,"mailfetch_subfolder_$mf_sn",(isset($mf_subfolder)?$mf_subfolder:""));
	if ($mf_action_m != 1) {
	    $mf_sn++;
    	    setPref($data_dir,$username,'mailfetch_server_number', $mf_sn);
	}
	$mf_sn = "";
        break;
    case 'delete':
        //delete    a server
        $mailfetch_server_number    = getPref($data_dir, $username, "mailfetch_server_number");
        if ($mf_sn+1==$mailfetch_server_number) {
            //is the last server, whe can only decrase $mailfetch_server_number
            $mailfetch_server_number--;
            setPref($data_dir,$username,"mailfetch_server_number", $mailfetch_server_number);
        } else {
            //if not the last, all the sequel server come up one step
            //then whe decrase $mailfetch_server_number
            $mailfetch_server_number--;
            for ($i=$mf_sn;$i<$mailfetch_server_number;$i++) {
                $tmp=$i+1;
                setPref($data_dir,$username,'mailfetch_server_'.$i,
                    getPref($data_dir,$username, 'mailfetch_server_'.$tmp));
                setPref($data_dir,$username,'mailfetch_port_'.$i,
                    getPref($data_dir,$username, 'mailfetch_port_'.$tmp));
                setPref($data_dir,$username,'mailfetch_alias_'.$i,
                    getPref($data_dir,$username, 'mailfetch_alias_'.$tmp));
                setPref($data_dir,$username,'mailfetch_user_'.$i,
                    getPref($data_dir,$username, 'mailfetch_user_'.$tmp));
                setPref($data_dir,$username,'mailfetch_pass_'.$i,
                    getPref($data_dir,$username, 'mailfetch_pass_'.$tmp));
                setPref($data_dir,$username,'mailfetch_lmos_'.$i,
                    getPref($data_dir,$username, 'mailfetch_lmos_'.$tmp));
                setPref($data_dir,$username,'mailfetch_login_'.$i,
                    getPref($data_dir,$username, 'mailfetch_login_'.$tmp));
                setPref($data_dir,$username,'mailfetch_fref_'.$i,
                    getPref($data_dir,$username, 'mailfetch_fref_'.$tmp));
                setPref($data_dir,$username,'mailfetch_subfolder_'.$i,
                    getPref($data_dir,$username, 'mailfetch_subfolder_'.$tmp));
		setPref($data_dir,$username,'mailfetch_uidl_'.$i,
                    getPref($data_dir,$username, 'mailfetch_uidl_'.$tmp));
            }
            setPref($data_dir,$username,"mailfetch_server_number", $mailfetch_server_number);
        }
	$mf_sn="";
        break;
    }
    $mailfetch_server_number = getPref($data_dir, $username, 'mailfetch_server_number', 0);
    $mailfetch_cypher = getPref( $data_dir, $username, 'mailfetch_cypher' );
    if ($mailfetch_server_number<1) {
        $mailfetch_server_number=0;
    }
    for ($i=0;$i<$mailfetch_server_number;$i++) {
        $mailfetch_server_[$i] = getPref($data_dir, $username, "mailfetch_server_$i");
        $mailfetch_port_[$i] = getPref($data_dir, $username, "mailfetch_port_$i");
        $mailfetch_alias_[$i] = getPref($data_dir, $username, "mailfetch_alias_$i");
        $mailfetch_user_[$i] = getPref($data_dir, $username, "mailfetch_user_$i");
        $mailfetch_pass_[$i] = getPref($data_dir, $username, "mailfetch_pass_$i");
        $mailfetch_lmos_[$i] = getPref($data_dir, $username, "mailfetch_lmos_$i");
        $mailfetch_login_[$i] = getPref($data_dir, $username, "mailfetch_login_$i");
        $mailfetch_fref_[$i] = getPref($data_dir, $username, "mailfetch_fref_$i");
        $mailfetch_uidl_[$i] = getPref($data_dir, $username, "mailfetch_uidl_$i");
        $mailfetch_subfolder_[$i] = getPref($data_dir, $username, "mailfetch_subfolder_$i");
        if( $mailfetch_cypher == 'on' ) $mailfetch_pass_[$i] = decrypt( $mailfetch_pass_[$i] );
    }

//************** Start HTML *****************************************//

$js = 'function OnSubmit() {
        var a = document.f;
        if (CtrlNull(a.mf_server.value)){
            alert("'.jsspecialchars(_("An obligatory field is missing!")).'");
            a.mf_server.focus();
            return false;
	}
        if (CtrlNull(a.mf_port.value)){
            alert("'.jsspecialchars(_("An obligatory field is missing!")).'");
            a.mf_port.focus();
            return false;
	}
        if (CtrlNull(a.mf_user.value)){
            alert("'.jsspecialchars(_("An obligatory field is missing!")).'");
            a.mf_user.focus();
            return false;
	}
	return true;
    }';
$js = '<script language="javascript">'.$js.'</script>'; 

$optpage_name = _("Fetch Mail");   

displayHtmlHeader(_("Options - Fetch Mail"),$js);  

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/tips.js"></script>';
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/ctrl_form.js"></script>';

echo '<body>';

echo '<table class="border" valign="top" width="100%" height="100%" cellpadding="0" cellspacing="0" border="0">';
 
ShowOptionBar();

if (!isset($mf_sn) || $mf_sn == '') {
    $mailfetch_server_number = getPref($data_dir, $username, 'mailfetch_server_number', 0);
    $mf_sn = $mailfetch_server_number;
}
echo '<tr valign="top"><td width="100%" height="1%" valign="top">'; 
    echo addForm($PHP_SELF, 'POST', 'f');
    echo addHidden('mf_sn', $mf_sn);
    echo addHidden('mf_action', 'add');
    echo addHidden('mf_fref', '0');
    echo addHidden('mf_login', '0');
    if (isset($mailfetch_server_[$mf_sn]) && $mailfetch_server_[$mf_sn]) {
	echo addHidden('mf_action_m', '1');
    }
    echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	echo '<tr height="1%">
        	<td align="left" width="100%" class="optionlink">
		    '.codeHTML(_("Remote POP server settings")).'
		</td>
	    </tr>'."\n";
	echo '<tr height="1%">
        	<td align="left" class="nav">
                    '.codeHTML(_("You should be aware that the encryption used to store your password is not perfectly secure.  However, if you are using pop, there is inherently no encryption anyway. Additionally, the encryption that we do to save it on the server can be undone by a hacker reading the source to this file.")."\n\n"._("If you leave password empty, it will be required when you fetch mail.")).'
        	</td>
    	    </tr>'."\n";
    if ($mailfetch_cypher=='on') { $mail_fetch_checked=TRUE; } else { $mail_fetch_checked=FALSE; }
    echo '<tr height="1%">
            <td align="right" class="nav">';
		echo addCheckBox('mf_cypher', $mail_fetch_checked)._("Encrypt passwords (informative only)");
            echo '</td>
        </tr>'."\n";
    echo '</table></td></tr>';
echo '<tr valign="top"><td width="100%" height="1%" valign="top">'; 
    echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	echo '<tr height="1%">
        	<td align="left" width="100%" class="optionlink" colspan=2>
		    '.codeHTML(_("Add/Modify Server")).'
		</td>
	    </tr>'."\n";
	$mf_server="";
	if (isset($mailfetch_server_[$mf_sn]) && $mailfetch_server_[$mf_sn]) { $mf_server=htmlspecialchars($mailfetch_server_[$mf_sn]); } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Server")) . ':
        	</td>
        	<td align="left" class="nav">';
		    echo addInput('mf_server', $mf_server);
        	echo '</td>
	    </tr>'."\n";
	$mf_port="110";    
	if (isset($mailfetch_port_[$mf_sn]) && $mailfetch_port_[$mf_sn]) { $mf_port=$mailfetch_port_[$mf_sn]; } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Port")) . ':
        	</td>
        	<td align="left" class="nav">';
		echo addInput('mf_port',$mf_port);
        echo '	</td>
	    </tr>'."\n";    
	$mf_alias="";    
	if (isset($mailfetch_alias_[$mf_sn]) && $mailfetch_alias_[$mf_sn]) { $mf_alias=htmlspecialchars($mailfetch_alias_[$mf_sn]); } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Alias")) . ':
        	</td>
        	<td align="left" class="nav">';
        	echo addInput('mf_alias',$mf_alias);
        echo '	</td>
	    </tr>'."\n";    
	$mf_user="";    
	if (isset($mailfetch_user_[$mf_sn]) && $mailfetch_user_[$mf_sn]) { $mf_user=htmlspecialchars($mailfetch_user_[$mf_sn]); } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Username")) . ':
        	</td>
        	<td align="left" class="nav">';
		    echo addInput('mf_user',$mf_user);
        echo '	</td>
	    </tr>'."\n";    
	$mf_pass="";    
	if (isset($mailfetch_pass_[$mf_sn]) && $mailfetch_pass_[$mf_sn]) { $mf_pass=htmlspecialchars($mailfetch_pass_[$mf_sn]); } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Password")) . ':
        	</td>
        	<td align="left" class="nav">';
		    echo addPwField('mf_pass' , $mf_pass);
        	echo '</td>
	    </tr>'."\n";    
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
            	    '.codeHTML(_("Store in Folder")) . ':
        	</td>
        	<td align="left" class="nav">';
		    $new_option =  array();
    		    $imapConnection = sqimap_login ($username, $key, $imapServerAddress, $imapPort, 0);
    		    $boxes = sqimap_mailbox_list($imapConnection);
    		    $selected = 0;
		    if ( isset($mf_subfolder) ) {
        		$selected = array(strtolower($mf_subfolder));
			$myselected = $mf_subfolder;
		    } else if ( isset($mailfetch_subfolder_[$mf_sn]) ) {
        		$selected = array(strtolower($mailfetch_subfolder_[$mf_sn]));
			$myselected = $mailfetch_subfolder_[$mf_sn];
    		    }
    		    $new_option = sqimap_mailbox_option_list($imapConnection, $selected);
		    echo addSelect('mf_subfolder', $new_option, $myselected, TRUE);
		echo '</td>';
	    echo '</tr>'."\n";    
	$mf_lmos="";    
	if (isset($mailfetch_lmos_[$mf_sn]) && $mailfetch_lmos_[$mf_sn] == 'on') { $mf_lmos=TRUE; } else { $mf_lmos=FALSE; } 
	echo '<tr height="1%">
        	<td align="left" width="30%" class="nav">
		    &nbsp;
        	</td>
        	<td align="left" class="nav">';
		    echo addCheckBox('mf_lmos', $mf_lmos)._("Leave Mail on Server");
        	echo '</td>
	    </tr>'."\n";    
    echo '<tr height="1%" valign="top">
            <td align="center" width="100%" class="nav" colspan=2>';
	    echo addButton( _("Confirm") ,'','','','f','OnSubmit()');
    echo '  </td>
        </tr>';
    echo "</form>\n";
    echo '</table></td></tr>';
if ($mailfetch_server_number>0) {
    echo '<tr valign="top" height="10">
            <td class="nav" align="center" width="100%">
                &nbsp;
            </td>
    </tr>';
    echo '<tr valign="top"><td height="1%">';
	echo '<table class="border" width="100%" height="1%" align="center" valign="top" cellpadding="2" cellspacing="2" border="0">';
	    echo '<tr height="1%">
        	    <td align="left" width="100%" class="optionlink" colspan=6>
            		'.codeHTML(_("Server list")).'
        	    </td>
    		</tr>'."\n";
	    echo '<tr height="1%">
        	    <td align="left" width="8%" class="optionlink">&nbsp;</td>
        	    <td align="left" width="8%" class="optionlink">&nbsp;</td>
        	    <td align="center" width="14%" class="optionlink">'.codeHTML(_("Server")).'</td>
        	    <td align="center" width="14%" class="optionlink">'.codeHTML(_("Port")).'</td>
        	    <td align="center" width="14%" class="optionlink">'.codeHTML(_("Alias")).'</td>
        	    <td align="center" width="14%" class="optionlink">'.codeHTML(_("Username")).'</td>
    		</tr>'."\n";
        for ($i=0;$i<$mailfetch_server_number;$i++) {
	    if ($mailfetch_server_[$i]) {
		if (!$mailfetch_server_[$i]) { $mailfetch_server_[$i]="&nbsp;"; }
		if (!$mailfetch_user_[$i]) { $mailfetch_user_[$i]="&nbsp;"; }
		if (!$mailfetch_port_[$i]) { $mailfetch_port_[$i]="&nbsp;"; }
		if (!$mailfetch_alias_[$i]) { $mailfetch_alias_[$i]="&nbsp;"; }
		echo'<tr height="1%">
    		    <td width="8%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/mail_fetch/options_fetch_mail.php?mf_action=config&mf_sn='.$i.'\'" valign="middle" align="center" class="nav">'.codeHTML(_("Edit")).'</td>
    		    <td width="8%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'plugins/mail_fetch/options_fetch_mail.php?mf_action=delete&mf_sn='.$i.'\'" valign="middle" align="center" class="nav">'.codeHTML(_("Delete")).'</td>
    		    <td width="14%" valign="middle" align="center" class="nav">'.codeHTML($mailfetch_server_[$i]).'</td>
    		    <td width="14%" valign="middle" align="center" class="nav">'.codeHTML($mailfetch_port_[$i]).'</td>
    		    <td width="14%" valign="middle" align="left" class="nav">'.codeHTML($mailfetch_alias_[$i]).'</td>
    		    <td width="14%" valign="middle" align="left" class="nav">'.codeHTML($mailfetch_user_[$i]).'</td>
		</tr>';
	    }
    	}
} else {
    echo '<tr><td height="100%" align="center" valign="middle" class="nav" width="100%">';
    echo codeHTML(_("No Server is defined and in use")) . "</td></tr>";
}
   echo '<tr valign="top">
            <td class="nav" align="center" width="100%" colspan=6>
                &nbsp;
            </td>
        </tr>';
echo '</table>';
echo $echotips;
echo '</body></html>';

?>