<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

// make sure SM_PATH is defined
if (!defined('SM_PATH'))  { define('SM_PATH','../../'); }

global $qmlogin_cgi_url, $domain, $minimumPasswordLength, $PathChpwd;

// load required files
include_once(SM_PATH . 'include/validate.php');
include_once(SM_PATH . 'functions/forms.php');
// add sqm_baseuri function
include_once(SM_PATH . 'functions/display_messages.php');

sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('Login',  $Login,      SQ_POST);

// extract username and domain
if (preg_match("/^(.+)@(.+)/",$username,$qmlogin_match)) {
    $qmlogin_username=$qmlogin_match[1];
    $qmlogin_domain=$qmlogin_match[2];
} else {
    $qmlogin_username=$username;
    $qmlogin_domain=$domain;
}

if ($qmlogin_cgi_url == 1 && !$Login) {
    $js = '<script language="javascript">
    var msgobligatory = "'.jsspecialchars(_("No password submitted")).'";
    var msgnonewpasswd = "'.jsspecialchars(_("New passords is not equal")).'";
    </script>';
} else {
    $js = "";
}

displayHtmlHeader('',$js);

if ($Login) {
    sqgetGlobalVar('password',  $old,      SQ_POST);
    sqgetGlobalVar('newpassword1',  $new1,      SQ_POST);
    sqgetGlobalVar('newpassword2',  $new2,      SQ_POST);
    $currentPassword = OneTimePadDecrypt($key, $onetimepad);

    if (!$new1 || !$new2) {
	$msg = "No password changed";
        $message = codeHTML(_("Missing new password"));
    } else if (!$old) {
	$msg = "No password changed";
        $message = codeHTML(_("Missing current password"));
    } else if ($new1 != $new2) {
	$msg = "No password changed";
        $message = codeHTML(_("Your new password is not correct"));
    } else if (!$qmlogin_username) {
	$msg = "No password changed";
        $message = codeHTML(_("Missing username"));
    } else if ($currentPassword != $old_pw) {
	$msg = "No password changed";
        $message = codeHTML(_("Your current password is not correct"));
    } else if ($minimumPasswordLength > 0 && strlen($new1) < $minimumPasswordLength) {
	$msg = "No password changed";
        $message = codeHTML(_("Your new password should be longer (chars): ")).$minimumPasswordLength;
    } else if (!$PathChpwd) {
	$msg = "No password changed";
        $message = codeHTML(_("You should configure PathChpwd in config_local.php."));
    } else {
	$new1 = escapeshellarg($new1);
	$old = escapeshellarg($old);
	$user = escapeshellarg($qmlogin_username);
        $status = array(
		 1 => codeHTML(_("You should setuid chpasswd")),
                 2 => codeHTML(_("Missing new password")),
                 3 => codeHTML(_("Missing current password")),
                 4 => codeHTML(_("The password for this user cannot be changed due to security constraints")),
                 5 => codeHTML(_("The new password is equal to the current password. Choose another password.")),
                 6 => codeHTML(_("Could not read password file")),
                 7 => codeHTML(_("Could not read password file")),
                 8 => codeHTML(_("Temporary file could not be opened")),
                 9 => codeHTML(_("Current password is incorrect")),
                10 => codeHTML(_("User does not exist.")),
                11 => codeHTML(_("Virtual memory exhausted")),
                12 => codeHTML(_("Missing username")),
		126 => codeHTML(_("Permission denied")),
        );
	$cmd = "$PathChpwd $user $old $new1 2>/dev/null 1>&2";
	exec($cmd,$error,$ret);
        if (isset($status[$ret])) {
            $message = $status[$ret];
        } else if ($ret) {
            $message = codeHTML(_("An error has occurred while attempting to change your password."));
	}    
        if (!$ret) {
            $msg = "Your password was changed successfully.";
	} else {
	    $msg = "No password changed";
	}
    }
    echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
    if ($msg) {
	echo '<tr height="1%">
                <td align="center" width="100%" class="nav" colspan=2>
                    '.codeHTML(_("$msg")).'
                </td>
            </tr>'."\n";
    }
    echo '<tr height="1%">
                <td align="center" width="100%" class="nav" colspan=2>
		    &nbsp;
                </td>
            </tr>'."\n";
    if ($message) {
	echo '<tr height="1%">
                <td align="center" width="100%" class="nav" colspan=2>
                    '.$message.'
                </td>
            </tr>'."\n";
    }
    echo '<tr height="1%" valign="top">
            <td align="center" width="100%" class="nav" colspan=2>';
	    echo addButton(_("Close"), '','','parent.close();','','',1,1);
    echo '</td></tr>';
	echo '<tr>
                <td align="left" width="100%" class="nav" colspan=2>
		    &nbsp;
                </td>
            </tr>'."\n";
    echo '</table>';
} else if ($qmlogin_cgi_url == 1) {
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/ctrl_form.js"></script>';
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/qmail_login.js"></script>';
    echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	echo addForm($base_uri.'plugins/qmailadmin_login/qmail_login.php','post','qmlogin_user');
	echo addHidden('Login',1);
	echo '<tr height="1%">
                <td align="left" width="100%" class="optionlink" colspan=2>
                    '.codeHTML(_("Change your password")).'
                </td>
            </tr>'."\n";
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
                    '.codeHTML(_("Username")) . ':
                </td>
                <td align="left" class="nav">
		    '.$qmlogin_username.'
                </td>
            </tr>'."\n";
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
                    '.codeHTML(_("Old password")) . ':
                </td>
                <td align="left" class="nav">';
                    echo addPwField('password');
                echo '</td>
            </tr>'."\n";
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
                    '.codeHTML(_("New password")) . ':
                </td>
                <td align="left" class="nav">';
                    echo addPwField('newpassword1');
                echo '</td>
            </tr>'."\n";
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
                    '.codeHTML(_("Confirm new password")) . ':
                </td>
                <td align="left" class="nav">';
                    echo addPwField('newpassword2');
                echo '</td>
            </tr>'."\n";
    echo '<tr height="1%" valign="top">
            <td align="center" width="100%" class="nav" colspan=2>';
	    echo addButton(_("Confirm"),'','','','qmlogin_user','OnSubmit()');
    echo '</td></tr>';
	echo '<tr>
                <td align="left" width="100%" class="nav" colspan=2>
		    &nbsp;
                </td>
            </tr>'."\n";
    echo "</form></table>";
} else {
    echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	echo addForm($qmlogin_cgi_url,'post','qmlogin_user');
	echo addHidden('username',$qmlogin_username);
	echo addHidden('domain',$qmlogin_domain);
	echo addHidden('returnhttp','');
	echo addHidden('returntext','');
	echo '<tr height="1%">
                <td align="left" width="100%" class="optionlink" colspan=2>
                    '.codeHTML(_("Please confirm your password in order to access account management pages")).'
                </td>
            </tr>'."\n";
        echo '<tr height="1%">
                <td align="left" width="30%" class="nav">
                    '.codeHTML(_("Your password")) . ':
                </td>
                <td align="left" class="nav">';
                    echo addPwField('password');
                echo '</td>
            </tr>'."\n";
    echo '<tr height="1%" valign="top">
            <td align="center" width="100%" class="nav" colspan=2>';
            echo addButton( _("Login") ,'Login','','','qmlogin_user');
    echo '</td></tr>';
	echo '<tr>
                <td align="left" width="100%" class="nav" colspan=2>
		    &nbsp;
                </td>
            </tr>'."\n";
    echo "</form></table>";
}

echo '</body></html>';

?>