<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * addressbook.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Manage personal address book.
 *
 * $Id: addressbook_group.php,v 1.3 2004/06/02 10:10:39 marco Exp $
 */
/*
   Autori:             Marco Colombo (marco@openit.it)
                       Valentina Portolan (valentina@openit.it)
                       Giuliano Natali Diaolin (diaolin@openit.it)
   Copyright:          Open It S.r.l.
                       Viale Dante, 78
                       38057 Pergine Valsugana (TN) ITALY
                       Tel: +39 0461 534800 Fax: +39 0461 538443
*/

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/addressbook_nav.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

/* lets get the global vars we may need */
sqgetGlobalVar('key',       $key,           SQ_COOKIE);

sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);

//operazioni su i gruppi di contatti
sqgetGlobalVar('addgroup',   $addgroup,   SQ_POST);
sqgetGlobalVar('editgroup',  $editgroup,  SQ_POST);
sqgetGlobalVar('delgroup',   $delgroup,   SQ_POST);

// parametri
sqgetGlobalVar('sel',       $sel,       SQ_POST);
sqgetGlobalVar('backend',   $backend,   SQ_POST);
sqgetGlobalVar('newbackend',   $newbackend,   SQ_POST);
sqgetGlobalVar('start_contact', $start_contact, SQ_GET); 

global $address_book_count, $show_fieldarraygroupabook, $fieldarraygroupabook, $custom_css, $global_abook_master;

/* Sort array by the key "name" */
function alistcmpoverlook($a,$b) {
    return (strtolower($a['group_name']) > strtolower($b['group_name'])) ? 1 : -1;
}

$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
}

if($gabook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal group address book is defined. Contact administrator.")),
        $color);
    exit();
}

$errstr="";

/* Handle user's actions */
if((sqgetGlobalVar('REQUEST_METHOD', $req_method, SQ_SERVER) && $req_method == 'POST') || $searchaddr) {
    if ($addgroup) {
        $newdata = array();
	foreach ($fieldarraygroupabook as $namehidden => $v) {
	    if ($namehidden == "group_id") { continue; }
	    sqgetGlobalVar($namehidden, $newdata[$namehidden],   SQ_POST);
	}
	if ($newbackend == 2) {
    	    $r = $gabook->add($newdata, $newbackend, $abook);
	} else {
    	    $r = $gabook->add($newdata, $gabook->localbackend, $abook);
	}
        /* Handle error messages */
        if (!$r) {
            /* Remove backend name from error string */
            $errstr = $gabook->error;
            $errstr = ereg_replace('^\[.*\] *', '', $errstr);
        }
	displayHtmlHeader (_("Addressbook"));

	echo '<body onload="self.focus();">';
	echo '<script language="javascript">window.resizeTo(400,200);</script>'."\n";  
	echo '<table valign="top" height="100%" cellpadding=0 cellspacing=0 border=0 width="100%">'."\n";
	if ($errstr) {
	    echo '<tr height="70%"><td valign="middle" align="center" class="error">';
		echo codeHTML($errstr);
	} else {
	    echo '<tr height="70%"><td valign="middle" align="center" class="success">';
		echo codeHTML(_("Addressbook updated succesfully."));
	}
    	echo '</td></tr>';
	echo '<tr height="30%">
		<td align="center" class="nav" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onClick="parent.opener.document.location.reload(); window.close()">
		    '.codeHTML(_("Close")).'
		</td>
	     </tr>
	    </table></body></html>';
	exit();          
    /************************************************
    * Delete group                                  *
    ************************************************/
    } else if ($delgroup && $sel) {
        /* The selected addresses are identidied by "backend:nickname". *
        * Sort the list and process one backend at the time            */
        $delfailed = false;
        list($sbackend, $snick) = explode(':', $sel);
        $r = $gabook->remove($snick, $sbackend);
        if (!$r) {
            $errstr = $gabook->error;
            $errstr = ereg_replace('^\[.*\] *', '', $errstr);
        }
    /************************************************
    * Modify group                                  *
    ************************************************/
    } else if ($editgroup && $sel) {
        $newdata = array();
	foreach ($fieldarraygroupabook as $namehidden => $v) {
	    if ($namehidden == "group_id") { continue; }
	    sqgetGlobalVar($namehidden, $newdata[$namehidden],   SQ_POST);
	}
	list($sbackend, $snick) = explode(':', $sel);
	if ($newbackend && $newbackend == 2 && $sbackend == 1) {
    	    $r = $gabook->remove($snick, $sbackend);
    	    $r = $gabook->add($newdata, $newbackend);
	} else if ($sbackend == 2 && !$newbackend) {
    	    $r = $gabook->remove($snick, $sbackend);
    	    $r = $gabook->add($newdata, 1);
	} else {
	    $newdata['group_id']=$snick;
    	    $r = $gabook->modify($snick, $newdata, $sbackend);
	}
        /* Handle error messages */
	$errstr = $gabook->error;
	$errstr = ereg_replace('^\[.*\] *', '', $errstr);

	displayHtmlHeader (_("Addressbook"));

	echo '<body onload="self.focus();">';
	echo '<script language="javascript">window.resizeTo(400,200);</script>'."\n";  
	echo '<table valign="top" height="100%" cellpadding=0 cellspacing=0 border=0 width="100%">'."\n";
	if ($errstr) {
	    echo '<tr height="70%"><td valign="middle" align="center" class="error">';
		echo codeHTML($errstr);
	} else {
	    echo '<tr height="70%"><td valign="middle" align="center" class="success">';
		echo codeHTML(_("Addressbook updated succesfully."));
	}
    	echo '</td></tr>';
	echo '<tr height="30%">
		<td align="center" class="nav" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onClick="parent.opener.document.location.reload(); window.close()">
		    '.codeHTML(_("Close")).'
		</td>
	     </tr>
	    </table></body></html>';
	exit();          
    }
}

/* Get and sort address group list */
$alist = $gabook->list_addr();


displayHtmlHeader (_("Addressbook"),'');

displayJavascriptAddressBook();

echo '<body onload="self.focus();">';
/* =================================================================== *
 * The following is only executed on a GET request, or on a POST when  *
 * a user is added, or when "delete" or "modify" was successful.       *
 * =================================================================== */

    if(!is_array($alist)) {
        plain_error_message(codeHTML($gabook->error), $color);
        exit;
    }

    usort($alist,'alistcmpoverlook');    

    $prevbackend = -1;
    $headerprinted = false;

    echo '<div id="div_new" style="position:absolute;z-index:16;visibility:hidden;top:0px;left:0px;">
	    <table align="left" valign="top" class="border" cellpadding=2 cellspacing=0 border=0>
		<tr><td onClick="CreateAdd(1)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Contact")).'</td></tr>
		<tr><td onClick="CreateAdd(2)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Private Group")).'</td></tr>';
    if (in_array($username,$global_abook_master)) {	
	echo '<tr><td onClick="CreateAdd(3)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Public Group")).'</td></tr>';
    }
    echo '</table></div>';

    echo '<table valign="top" cellpadding=0 cellspacing=0 border=0 width="100%" height="100%">'."\n";
	echo '<tr><td height="1%" valign="top">';
	    displayNavigationAddressBook(1);
        echo '</td></tr>';
    if ($errstr) {
	echo '<tr><td height="1%" valign="middle" align="center" class="error">';
	    echo codeHTML($errstr);
        echo '</td></tr>';
    }
    echo addForm($base_uri.'src/addressbook_group.php', 'POST', 'f');
    echo addHidden('sel', '');
    echo addHidden('delgroup', '0');
    echo addHidden('editgroup', '0');
    echo addHidden('adgroup', '0');
    echo addHidden('newbackend', '');
    foreach ($fieldarraygroupabook as $namehidden => $v) {
	if ($namehidden == "group_id") { continue; }
	echo addHidden($namehidden, '');
    }
    if (!count($alist) || count($alist) == 0) {
	echo '<tr><td width="100%" align="center" valign="middle" class="nav">';  
	    echo codeHTML(_("The addressbook is empty."));
	    echo '</td></tr>';
    	    echo '</form>';
	    echo '</table></td></tr>';
    } else {
	echo '<tr><td height="1%" valign="top">';
	    echo '<table height="1%" class="border" width="100%" align="center" valign="top" cellspacing=2 cellpadding=3 border=0 valign="top">' . "\n";
                echo '<tr width="100%" height="1%">
                        <td class="addressbookth" align="center" width="20">&nbsp;</td>
                        <td class="addressbookth" align="center" width="20">&nbsp;</td>';
                foreach ($show_fieldarraygroupabook as $key) {
                    echo '<td class="addressbookth" align="left">'.codeHTML(_($fieldarraygroupabook[$key]["label"])).'</td>';
                }
                echo '</tr>';
		$n_contacts=count($alist);  
		$id=0; 
		$modify_global=0;
		if (in_array($username,$global_abook_master)) { $modify_global=1; }
		while(list($undef,$row) = each($alist)) {
		    if ($id >= $start_contact && $id < ($start_contact+$address_book_count)) { 
			echo '<tr height="1%">';
        		    if ($row['source'] == _("Global group address book")) {
				if ($modify_global) {
				    echo '<td onclick="ModifySelected(\''.$row['backend'].':'.$row['group_id'].'\',1);" class="abookglobal" onmouseover="this.className=\'abookglobalclicked\'" onmouseout="this.className=\'abookglobal\'" align="center" width="20">';
					    echo '<img alt="'._("Edit Global").'" src="'.$base_uri.'images/'.$custom_css.'/edit_small.gif" border=0>';
					echo '</td>';
					echo '<td onclick="DeleteSelected(\''.$row['backend'].':'.$row['group_id'].'\',1);" class="abookglobal" onmouseover="this.className=\'abookglobalclicked\'" onmouseout="this.className=\'abookglobal\'" align="center" width="20">';
                                    	    echo '<img alt="'._("Trash Global").'" src="'.$base_uri.'images/'.$custom_css.'/delete_small.gif" border=0>';
                                	echo '</td>';
				} else {
            			    echo '<td class="abookglobal" align="center" width="20">';
					    echo '<img alt="'._("Public").'" src="'.$base_uri.'images/'.$custom_css.'/post_it.gif" border=0>';
					echo '</td>';
					echo '<td class="abookglobal" align="center" width="20">';
				    	    echo '&nbsp;';
                                	echo '</td>';
				}
        		    } else {
				echo '<td onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="ModifySelected(\''.$row['backend'].':'.$row['group_id'].'\',1);" class="nav" align="center" width="20">';
					echo '<img alt="'._("Edit").'" src="'.$base_uri.'images/'.$custom_css.'/edit_small.gif" border=0>';
				    echo '</td>';
				    echo '<td onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="DeleteSelected(\''.$row['backend'].':'.$row['group_id'].'\',1);" class="nav" align="center" width="20">';
                                        echo '<img alt="'._("Trash").'" src="'.$base_uri.'images/'.$custom_css.'/delete_small.gif" border=0>';
                                    echo '</td>';
			    }
			    foreach ($show_fieldarraygroupabook as $key) {
                                if ($fieldarraygroupabook[$key]['functions']) {
                                    eval('$value='.$fieldarraygroupabook[$key]['functions'].'("'.$row[$key].'");');
                                } else { $value = $row[$key]; }
                                if ($value) {
                                    echo '<td class="nav" align="'.codeHTML($fieldarraygroupabook[$key]['align']).'">'.$value.'</td>';
                                } else {
                                    echo '<td class="nav" align="left">&nbsp;</td>';
                                }
                            }
			echo '</tr>'."\n";
		    }
		    $id++;
    		}
		echo '</form>';
		echo '</table></td></tr>';
	    if ($searchaddr) {
		$urlsearch = '&searchaddr='.$searchaddr.'&searchstring='.urlencode($searchstring).'&searchfield='.$searchfield.'&searchbackend='.$searchbackend;
	    } else {
		$urlsearch = "";
	    }
	    echo '<tr><td valign="top" align="center" class="nav" width="100%">';
		if ($start_contact >= $address_book_count) {
    		    echo '<a href="'.$base_uri.'src/addressbook.php?start_contact='.($start_contact-$address_book_count).$urlsearch.'">
            		    <img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer.gif">
            		</a>&nbsp;&nbsp;';
		} else {
    		    echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer_disabled.gif">&nbsp;&nbsp;';
		}
		if ($start_contact+$address_book_count < $n_contacts) {
    		    echo '<a href="'.$base_uri.'src/addressbook.php?start_contact='.($start_contact+$address_book_count).$urlsearch.'">
            		    <img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer.gif">
            		</a>';
		} else {
    		    echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer_disabled.gif">';
		}
	    echo '</td></tr>';
        echo '</table>';
    }
?>

</BODY></HTML>
