<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

/* lets get the global vars we may need */
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);  
sqgetGlobalVar('delimiter',  $delimiter,      SQ_SESSION);  

sqgetGlobalVar('nameform',      $nameform,      SQ_GET); 
sqgetGlobalVar('success', $success, SQ_GET); 
sqgetGlobalVar('subid', $subid, SQ_GET); 

global $lastTargetMailbox, $reload_tree_folder_on_folder_action;


if ( isset($success) && $success ) {
 
    $alarm = '';
 
    switch ($success)
    {
        case 'subscribe':
            $alarm .=  _("Subscribed successfully!");
            break;
        case 'unsubscribe':
            $alarm .=  _("Unsubscribed successfully!");
            break;
        case 'delete':
            $alarm .=  _("Deleted folder successfully!");
            break;
        case 'create':
            $alarm .=  _("Created folder successfully!");
            break;
        case 'empty':
            $alarm .=  _("Emptyed folder successfully!");
            break;
        case 'setspecial':
            $alarm .=  _("Set special folder successfully!");
            break;
        case 'unsetspecial':
            $alarm .=  _("Unset special folder successfully!");
            break;
        case 'rename':
            $alarm .=  _("Renamed successfully!");
            break;
        case 'subscribe-doesnotexist':
            $alarm .=  _("Subscription Unsuccessful - Folder does not exist.");
            break;
    }
}

$js = '<script language="Javascript">
    var msgnoselectedfolder = "'.jsspecialchars(_("Please select a folder!")).'";
    var msgnodeletedfolder = "'._("You can not delete this special folder").'";
    var msgnoemptyfolder = "'._("You can not empty this special folder").'";
    var msgnounsetspecialfolder = "'._("You can not unset this special folder").'";
    var msgnosetspecialfolder = "'._("You can set as special only first level folders").'";
    var msgnosubscribedfolder = "'._("You can not unsubscribe this special folder").'";
    var msgnoinsertedfolder = "'.jsspecialchars(_("Insert a name for new folder")).'";
    var msgnoinsertednewfolder = "'.jsspecialchars(_("Insert a new name for the folder")).'";
    var msgnorenamedfolder = "'.jsspecialchars(_("You can not rename this special folder")).'";
    var msgnocorrectfoldername = "'.jsspecialchars(_("Invalid folder name: use only character from A to Z and from 0 to 9 _ - and space!")).'";
    var imap_server_type = "'.strtolower($imap_server_type).'";
    var default_folder_prefix = "'.$default_folder_prefix.'";'."\n";
    if ($delimiter == '\\') { $jdelimiter = '\\\\'; } else { $jdelimiter = $delimiter; }
    if ($delimiter && $default_folder_prefix) {
	$js .= 'var root_folder = "'.preg_replace("/$jdelimiter$/", '', $default_folder_prefix).'";'."\n";
    } else {
	$js .= 'var root_folder = "'.$default_folder_prefix.'";'."\n";
    }
    $js .= '
    var trash_folder = "'.$trash_folder.'";
    var sent_folder = "'.$sent_folder.'";
    var draft_folder = "'.$draft_folder.'";
    var delimiter = "'.$jdelimiter.'";
</script>';

displayHtmlHeader(_("Folders"), $js);  

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/folders.js"></script>';

if ($success && $reload_tree_folder_on_folder_action) { $onload = 'opener.parent.left.location.reload();'; } else { $onload = ''; }

echo '<body onload="'.$onload.' document.cf.folder_name.focus(); self.focus();">';
echo addForm('#', 'POST', 'cf');
echo addHidden('subfolder', '');
echo addHidden('submethod', '');
echo addHidden('subid', '');
echo addHidden('resortly', '0');
echo '<table width="100%" class="border" height="100%" border=0 cellpadding=0 cellspacing=0 valign="top" align="center">';
if (isset($alarm) && $alarm) {
    echo '<tr height="1%">';
	echo '<td aling="center" class="success" colspan=2>'.codeHTML($alarm).'</td>';
    echo '</tr>';
}
if (strtolower($imap_server_type) == "uw") {
    echo '<tr height="1%">';
	echo '<td aling="center" class="success" colspan=2>'.codeHTML(_("This server is UW IMAP! The folder as created principal tree")).'</td>';
    echo '</tr>';
}
    echo '<tr height="1%">';
	echo '<td aling="left" colspan=2 class="nav">';
	    echo codeHTML(_("Folder name:")).'&nbsp;';
	    echo addInput('folder_name','','25');
	echo '</td>';
    echo '</tr>';
// non permetto creazione di sottocartelle in UW IMAP, le cartelle sono tutte nella tree principale
if ($show_contain_subfolders_option && strtolower($imap_server_type) != "uw") {
    echo '<tr height="1%">';
	echo '<td aling="left" colspan=2 class="nav">';
	    echo addCheckBox('contain_subs', FALSE).'&nbsp;'. _("Let this folder contain subfolders");
	echo '</td>';
    echo '</tr>';
}
    echo '<tr>';
	echo '<td class="unsubscribe" height="1%" valign="top" aling="center" colspan=2>';
	echo codeHTML(_('Unsubscribed folders'));
	echo '</td>';
    echo '</tr>';
    echo '<tr>';
	echo '<td class="specialfolder" height="1%" valign="top" aling="center" colspan=2>';
	echo codeHTML(_('Special folders'));
	echo '</td>';
    echo '</tr>';
    echo '<tr>';
	echo '<td width="60%" class="nav" valign="top" height="1%" aling="center">';
	    if ($subid) {
		echo '<iframe style="height:270px;width:95%" src="'.$base_uri.'src/tree_folders.php?force_refresh=TRUE#'.$subid.'">';
	    } else {
		echo '<iframe style="height:270px;width:95%" src="'.$base_uri.'src/tree_folders.php?force_refresh=TRUE">';
	    }
		echo codeHTML(_("Your browser doesn't support IFRAMES!"));   
	    echo '</iframe>';
	echo '</td>';
	echo '<td class="nav" valign="top" aling="center" height="1%">';
	    echo addButton(_("Create"), 'subcreate', 'style="width:100%"','OnCreate();','','OnSubmit(1,0)',0,2);
	    echo '<br>';
	    echo addButton(_("Rename"), 'subrename', 'style="width:100%"','OnRename();','','OnSubmit(2,1)',0,2);
	    echo '<br>';
	    echo addButton(_("Empty"), 'subempty','style="width:100%"','OnEmpty();','','OnSubmit(0,4)',0,2);
	    echo '<br>';
	    echo addButton(_("Empty resortly"), 'subemptyresortly','style="width:100%"','OnEmpty(1);','','OnSubmit(0,4)',0,2);
	    echo '<br>';
	    echo addButton(_("Delete"), 'subdelete','style="width:100%"','OnDelete();','','OnSubmit(0,2)',0,2);
	    echo '<br>';
	    echo addButton(_("Set as special"), 'subsetspecial','style="width:100%"','OnSetSpecial();','','OnSubmit(0,5)',0,2);
	    echo '<br>';
	    echo addButton(_("Unsubscribe"), 'subsubscribe','style="width:100%"','OnSubscribe();','','OnSubmit(0,3)',0,2);
	    echo '<br>';
	    if ($reload_tree_folder_on_action) {
	        echo addButton(_("Close"), '', 'style="width:100%"','parent.opener.left.location.reload(); window.close();','','',1,1);
	    } else {
	        echo addButton(_("Close"), '', 'style="width:100%"','window.close();','','',1,1);
	    }
	echo '</td>';
    echo '</tr>';
echo '</table></form></body></html>';

?>