<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../'); 

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'functions/mime.php');
require_once(SM_PATH . 'functions/mailbox_display.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/html.php');

global $custom_css;

function displayNavigation($mailbox, $xtra='', $session=false) {

    global $hide_sm_attributions, $PHP_SELF, $frame_top, $icon_folder,
           $compose_new_win, $auto_expunge, $custom_css, $use_pop3, $use_banner,
           $attachemessages, $provider_name, $provider_uri, $banner_timeout, 
           $javascript_on, $default_use_mdn, $mdn_user_support, $banners;

    sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );
    sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION );
    if ($session) {
        $compose_uri = $base_uri.'src/compose.php?mailbox='.urlencode($mailbox).'&attachedmessages=true&session='."$session";
    } else {
	$compose_uri = $base_uri.'src/compose.php?newmessage=1';
	$session = 0;
    }

    $js = "\n".'<script language="JavaScript" type="text/javascript">'."\n";
    $js.= ' var base_uri = "'.$base_uri.'";
	    var msgctrlchecked = "'.jsspecialchars(_("No messages were selected.")).'";
	    var msgctrlmessageid = "'.jsspecialchars(_("No messages opened.")).'";
	    var msgctrlmessageprint = "'.jsspecialchars(_("No messages opened.")).'";'."\n"; //" commento
    if ($use_banner && count($banners)) {
	$js .= 'var sponsor = 1;  
		var go = 1; 
		var banner_timeout = '.$banner_timeout.';
		var max = '.count($banners).';'."\n";
	    foreach ($banners as $n => $v) {
		$js .= 'var url'.$n.' = "'.$v['link'].'";'."\n";
		$js .= 'var text'.$n.' = "'.$v['text'].'";'."\n";
		$js .= 'var img'.$n.' = "'.$v['img'].'";'."\n";
	    }
    }
    $js .= '</script>'."\n";	

    displayHtmlHeader ('', $js);

    $urlMailbox = urlencode($mailbox);
    if ($use_banner && count($banners)) {
	echo "<body onload=\"window.setTimeout('parent.rotate();',".$banner_timeout.")\">\n\n";
    } else {
	echo "<body>\n\n";
    }
    echo '<table border="0" align="left" class="border" valign="top" width="100%" height="100%" cellspacing="0" cellpadding="0">';
	echo '<tr>';
	    echo '<td align="left" height="100%" class="altaltnav" valign="top">';
		echo '<table border="0" valign="top" align="left" height="100%" cellspacing="0" cellpadding="0">';
		    echo '<tr height="100%">';
			//ATTENZIONE: con onmouseout ed onmouseover bisogna dichiarare anche class=nav altrimenti le icone "vanno a spasso"    
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="parent.win_compose = parent.new_win_overlook(\'compose\',\''.$base_uri.'src/compose.php?mailbox='.$urlMailbox.'\',700,600,1,0,0);">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/compose.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Compose"));
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onClick="parent.CtrlMessageId()">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/view.gif" border=0>';
				echo '<br>';
			    }
			    echo '<div id="header">'.codeHTML(_("Header")).'</div>';
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="if (parent.CtrlChecked()) {
			parent.new_win_overlook(\'move\',\''.$base_uri.'src/move_email.php\',400,333,1,180,155); }">'; //commento "
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/mail_move.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Move"));
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="if (parent.CtrlChecked()) { parent.overlook_Action(\'markRead\'); }">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/read.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Read"));
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="if (parent.CtrlChecked()) { parent.overlook_Action(\'markUnread\'); }">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/unread.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Unread"));
			echo '</td>'."\n";
			if (!isset($passed_ent_id)) { $passed_ent_id=""; }
			if (!isset($passed_id)) { $passed_id=""; }
			$params='passed_ent_id=' . $passed_ent_id .
            		    '&mailbox=' . urlencode($mailbox) .
            		    '&passed_id=' . $passed_id;
			echo '<td align="center" width="1px" class="navseparator"></td>';
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onClick="parent.CtrlMessagePrint();">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/print.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Print"));
			echo '</td>'."\n";	
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onClick="if (parent.CtrlChecked()) { parent.reload_left_from_right=1; parent.message_id_selected=0; parent.overlook_Action(\'delete\'); }">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/delete.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Delete"));
			echo '</td>'."\n";		
			echo '<td align="center" width="1px" class="navseparator"></td>';
			if (!$auto_expunge) { 
		    	    echo '<td nowrap=1 class="altnav" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onClick="if (parent.CtrlChecked()) { parent.overlook_Action(\'expungeButton\'); }">';
				if ($icon_folder) {
				    echo '<img src="'.$base_uri.'images/'.$custom_css.'/mail_move.gif" border=0>';
				    echo '<br>';
				}
				echo codeHTML(_("Expunge")) .'&nbsp;' . codeHTML(_("mailbox"));
			    echo '</td>'."\n";		
			}
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="
			parent.new_win_overlook(\'folders\',\''.$base_uri.'src/folders.php\',400,330,1,180,150)">'; //"
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/folder.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Folders"));
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="
			parent.new_win_overlook(\'options\',\''.$base_uri.'src/options.php?mailbox='.$urlMailbox.'\',700,600,1,0,0)">'; //"
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/options.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Options"));
			echo '</td>'."\n";		
			echo '<td align="center" width="1px" class="navseparator"></td>';
			do_hook('menuline_overlook');
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="
			parent.new_win_overlook(\'address\',\''.$base_uri.'src/addressbook.php\',700,600,1,0,0)">'; //"
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/address.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Addresses"));
			echo '</td>'."\n";		
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="
			parent.new_win_overlook(\'search\',\''.$base_uri.'src/search.php?mailbox='.$urlMailbox.'\',700,600,1,0,0)">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/search.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Search"));
			echo '</td>'."\n";		
		    if ($use_pop3) {
			echo '<td align="center" width="1px" class="navseparator"></td>';
		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="55" onclick="
			parent.new_win_overlook(\'compose\',\''.$base_uri.'plugins/mail_fetch/fetch.php\',400,160,1,200,200)">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/mail_fetch.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Fetch"));
			echo '</td>'."\n";		
		    }
		    if ($use_banner) {
			echo '<td nowrap=1 class="altnav" align="center" height="100%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" valign="middle" width="55" onclick=\'if (parent.win_compose && !parent.win_compose.closed) { alert("'.jsspecialchars(_("ATTENTION: your compose window is active.")).'"); } else { parent.location.href="'.$base_uri.'src/signout.php"; }\'>';
			if ($icon_folder) {
    			    echo '<img src="'.$base_uri.'images/'.$custom_css.'/logoff.gif" border=0>';
			    echo '<br>';
			}
			echo codeHTML(_("Sign Out"));
			echo '</td>';
		    }
		    echo "</tr>\n";
		echo  "</table>\n\n";
	    echo "</td>";
	    echo '<td align="right" height="100%" class="altaltnav" valign="top">';
		echo '<table border="0" valign="top" align="right" height="100%" width="100%" cellspacing="0" cellpadding="0">';
		    echo '<tr height="100%" width="100%">';
		    if ($use_banner && count($banners)) {
			echo '<td nowrap=1 class="altnav" align="center" width="100%" height="100%" valign="middle">';
			echo '<div align="center" width:100%">
				<a href="javascript:parent.GoSponsor();" onmouseout="go=1;" onmouseover="go=0;parent.windowON();return true">
				    <img height=48 border=0 name="pic" src="'.$base_uri.'images/sponsor/'.$banners[1][img].'">
				</a>
			    </div>'."\n";
			echo '</td>';
		    } else if (!$use_banner) {
			echo '<td nowrap=1 class="altnav" align="center" height="100%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" valign="middle" width="55" onclick=\'if (parent.win_compose && !parent.win_compose.closed) { alert("'.jsspecialchars(_("ATTENTION: your compose window is active.")).'"); } else { parent.location.href="'.$base_uri.'src/signout.php"; }\'>';
			if ($icon_folder) {
    			    echo '<img src="'.$base_uri.'images/'.$custom_css.'/logoff.gif" border=0>';
			    echo '<br>';
			}
			echo codeHTML(_("Sign Out"));
			echo '</td>';
		    }
		    echo '</tr>';
		echo '</table>';			
	    echo "</td>\n";
	echo "</tr>\n";
    echo  "</table></body></html>\n\n";
}

sqgetGlobalVar('mailbox',   $mailbox); 

/* If the page has been loaded without a specific mailbox, */
/* send them to the inbox                                  */
if (!isset($mailbox)) {
    $mailbox = 'INBOX';
    $startMessage = 1;
}

displayNavigation($mailbox);

?>